#!/bin/bash
# by dancefan at www.octagon-forum.de
#File Handling

urldecode(){
  echo -e "$(sed 's/+/ /g; s/%/\\x/g')"
}

/var/www/cgi-bin/startpage.sh
#side Navi
scpath=`echo $QUERY_STRING | sed -e 's!.*srcpath=!!' -e 's!&.*!!' | urldecode`
newname=`echo $QUERY_STRING | sed -e 's!.*newname=!!' -e 's!&.*!!' | urldecode`
#destpath bestimmen
grep=`echo $QUERY_STRING | grep "destpath="`
if [ "$grep" ]; then
    destpath=`echo $QUERY_STRING | sed -e 's!.*destpath=!!' -e 's!&.*!!' | urldecode`
else
    destpath=$scpath;
fi

doit=`echo $QUERY_STRING | grep "doit="`
if [ $doit ]; then
    echo "<li><a href='/cgi-bin/20.Explorer.page?$scpath=$destpath'>Back</a></li>"
else
    echo "<li><a href='/cgi-bin/fileman_do.sh?doit=&$QUERY_STRING'>Ok</a></li>"
    echo "<li><a href='/cgi-bin/20.Explorer.page?$QUERY_STRING'>Cancel</a></li>"
fi

cat ./contentstart
echo "fileman_do.sh" >/tmp/webio.page


if [ $doit ]; then
    #Kommando ausfhren

    grep=`echo $QUERY_STRING | grep "fcmd=New+Folder"`
    if [ $grep ]; then
        mkdir "$scpath/$newname"
    else
        grep=`echo $QUERY_STRING | grep "fcmd=Delete+Folder"`
        if [ $grep ]; then
            rmdir "$scpath"
        else
            #File Liste abarbeiten
            help=$PWD
            cd "$scpath"
            echo $QUERY_STRING | sed -e 's!f=!!g' -e 's!&!\n!g' | while read start; do
                if [ $start -gt 0 ]; then
                    idx=1
                    while read Zeile; do
                        if [ $idx -eq $start ]; then
                            #.ts Files Sonderbehandlung
                            tspath=`echo "$Zeile" | sed -e 's!\.ts$!\\\.!'`
                            tsfilename=`echo "$Zeile" | sed -e 's!\.ts$!!'`
                            destfile=`echo "$tsfilename"`
                            fcounter=1
                            while [ -f "$destpath/$destfile.ts" ]; do
                                destfile=`echo "$tsfilename-$fcounter"`
                                fcounter=$(($fcounter + 1))
                            done
                            ls -1 -d * | grep "^$tspath" | while read tsfile; do
                                echo "$tsfile <br>"
                                ending=`echo "$tsfile" | sed -e 's!.*\.!!g'`
#kopieren
                                grep=`echo $QUERY_STRING | grep "fcmd=Copy"`
                                if [ $grep ]; then
                                    if [ -d "$destpath" ]; then
                                        echo "--> $destpath/$destfile.$ending <br>"
                                        cp -f "$tsfile" "$destpath/$destfile.$ending"
                                    else
                                        echo "Target directory is missing $destpath <br>"
                                    fi
                                fi
#verschieben
                                grep=`echo $QUERY_STRING | grep "fcmd=Move"`
                                if [ $grep ]; then
                                    if [ -d "$destpath" ]; then
                                        echo "... $destpath/$destfile.$ending <br>"
                                        mv "$tsfile" "$destpath/$destfile.$ending"
                                    else
                                        echo "Target directory is missing $destpath <br>"
                                    fi
                                fi
#loeschen
                                grep=`echo $QUERY_STRING | grep "fcmd=Delete"`
                                if [ $grep ]; then
                                    rm -f "$tsfile"
                                fi
#umbenennen
                                ren=`echo $QUERY_STRING | grep "fcmd=Rename"`
                                if [ $ren ]; then
                                    if [ -f $newname.$ending ]; then
                                        echo "File already exists $newname.$ending <br>"
                                    else
                                        mv "$tsfile" "$newname.$ending"
                                    fi
                                fi
                            done
                            if [ $ren ]; then
                                break 2
                            fi
                        fi
                        idx=$(($idx + 1))
                    done </tmp/webio.view
                fi
            done
            cd "$help"
        fi
    fi

    echo "<hr><h2>Done</h2>"
else
    #vorbereiten
    grep=`echo $QUERY_STRING | grep "fcmd=New+Folder"`
    if [ $grep ]; then
        echo "<h2>Create directory: $scpath/$newname</h2>"
        viewpath=0
    fi
    grep=`echo $QUERY_STRING | grep "fcmd=Delete+Folder"`
    if [ $grep ]; then
        echo "<h2>Delete directory: $scpath</h2>"
        viewpath=0
    fi
    grep=`echo $QUERY_STRING | grep "fcmd=Move"`
    if [ $grep ]; then
        echo "<h2>Move - destination directory: $destpath</h2>"
        viewpath=1
    fi
    grep=`echo $QUERY_STRING | grep "fcmd=Copy"`
    if [ $grep ]; then
        echo "<h2>Copy - destination directory: $destpath</h2>"
        viewpath=1
    fi
    grep=`echo $QUERY_STRING | grep "fcmd=Delete"`
    if [ $grep ]; then
        echo "<h2>Delete files?</h2>"
        viewpath=2
    fi
    grep=`echo $QUERY_STRING | grep "fcmd=Rename"`
    if [ $grep ]; then
        echo "<h2>Rename file?</h2>"
        viewpath=3
    fi
    #.*? funktioniert nicht
    cmdstring=`echo "$QUERY_STRING" | sed -e 's!destpath=.*&fcmd!fcmd!'`
    case $viewpath in
    1)
        echo "<div class='autoscroll' style='height:380px'>"
        echo "<table id='rectable'>"

        help=$PWD
        cd "$destpath"
        actpath=$PWD

        echo "<tr><td class='fileselect'>"
        echo "<a href='/cgi-bin/fileman_do.sh?destpath=$actpath/..&$cmdstring'>..</a></td></tr>"

        ls -1 -d * | while read Zeile; do
           	if [ -d "$actpath/$Zeile" ]; then
                echo "<tr><td class='recselect'>"
                echo "<a href='/cgi-bin/fileman_do.sh?destpath=$actpath/$Zeile&$cmdstring'>$actpath/$Zeile</a>"
            fi
            echo "</td></tr>"
        done
        cd "$help"
        echo "</table></div>";;
    2)
        echo "<div class='autoscroll' style='height:380px'>"
        echo "<table id='rectable'>"
        #File Liste anzeigen
        help=$PWD
        cd "$scpath"
        echo $QUERY_STRING | sed -e 's!f=!!g' -e 's!&!\n!g' | while read start; do
            if [ $start -gt 0 ]; then
                idx=1
                while read Zeile; do
                    if [ $idx -eq $start ]; then
                        echo "<tr><td>$Zeile</td></tr>"
                    fi
                    idx=$(($idx + 1))
                done </tmp/webio.view
            fi
        done
        cd "$help"
        echo "</table></div>";;
    3)
        echo "<div class='autoscroll' style='height:380px'>"
        #File Liste ersten Eintrag anzeigen
        help=$PWD
        cd "$scpath"
        echo $QUERY_STRING | sed -e 's!f=!!g' -e 's!&!\n!g' | while read start; do
            if [ $start -gt 0 ]; then
                idx=1
                while read Zeile; do
                    if [ $idx -eq $start ]; then
#                        newname=`echo $QUERY_STRING | sed -e 's!.*newname=!!' -e 's!&.*!!' | urldecode`
                        echo "<p>$Zeile<br/>New Filename (w/o extension):<br/>$newname<br/></p>"
                        break 2
                    fi
                    idx=$(($idx + 1))
                done </tmp/webio.view
            fi
        done
        cd "$help"
        echo "</div>";;
    esac
fi
cat ./footer
